import {
  DEBUG_ASYNC,
  DEBUG_SYNC,
  RELEASE_ASYNC,
  RELEASE_SYNC,
  newQuickJSAsyncWASMModule,
  newQuickJSWASMModule
} from "./chunk-F5EB3F4Q.mjs";

// src/index.ts
export * from "quickjs-emscripten-core";

// src/mod.ts
var singleton = void 0;
var singletonPromise = void 0;
async function getQuickJS() {
  singletonPromise ?? (singletonPromise = newQuickJSWASMModule().then((instance) => {
    singleton = instance;
    return instance;
  }));
  return await singletonPromise;
}
function getQuickJSSync() {
  if (!singleton) {
    throw new Error("QuickJS not initialized. Await getQuickJS() at least once.");
  }
  return singleton;
}
async function newAsyncRuntime(options) {
  const module = await newQuickJSAsyncWASMModule();
  return module.newRuntime(options);
}
async function newAsyncContext(options) {
  const module = await newQuickJSAsyncWASMModule();
  return module.newContext(options);
}
export {
  DEBUG_ASYNC,
  DEBUG_SYNC,
  RELEASE_ASYNC,
  RELEASE_SYNC,
  getQuickJS,
  getQuickJSSync,
  newAsyncContext,
  newAsyncRuntime,
  newQuickJSAsyncWASMModule,
  newQuickJSWASMModule
};
//# sourceMappingURL=index.mjs.map